/*+
|                                               |
|     Function: EXTRACT_TEL                     |
|                                               |
|      Extrair somente o nmero do telefone     |
|      Ex.: (31) 2122-2300 => 3121222300        |
|                                               |
|     Criao:                                  |
|     16/11/2007 - Danilo Faria                 |
|                                               |
+*/

create or replace
FUNCTION EXTRACT_TEL
  (P_NRTELEFONE IN VARCHAR2) RETURN VARCHAR2
IS
   V_NRTELEFONE      VARCHAR2(50)  := NULL;
   V_NRTEL_OK        CHAR(1)       := NULL;
   V_EXTRACTED_TEL   VARCHAR2(50)  := NULL;
   V_RETURN          VARCHAR2(50)  := NULL;
   
   V_LENGTH NUMBER;
   
   
BEGIN

   V_NRTELEFONE :=  SUBSTR(P_NRTELEFONE, 1,  INSTR(SUBSTR(P_NRTELEFONE||'/', 1, 50), '/'));

   BEGIN
      V_LENGTH :=  LENGTH(V_NRTELEFONE);
   EXCEPTION
      WHEN OTHERS THEN
         V_LENGTH := 0;
   END;

   WHILE V_LENGTH > 0 LOOP

      BEGIN      
         V_NRTEL_OK := SUBSTR(V_NRTELEFONE, V_LENGTH,  1);
      EXCEPTION
         WHEN OTHERS THEN
            V_NRTEL_OK := '';
      END;
      
      IF V_NRTEL_OK NOT IN('0', '1', '2', '3', '4', '5', '6', '7', '8', '9') THEN
         V_NRTEL_OK := ''; --> No permitir valores no numricos
      END IF;

      BEGIN
         V_EXTRACTED_TEL := V_EXTRACTED_TEL || V_NRTEL_OK; 

         V_EXTRACTED_TEL := REPLACE(V_EXTRACTED_TEL, ' ', '');
      EXCEPTION
         WHEN OTHERS THEN
           V_EXTRACTED_TEL := '';
      END;
      
      V_LENGTH := V_LENGTH - 1;
   END LOOP;
   
   BEGIN
      V_LENGTH :=  LENGTH(V_EXTRACTED_TEL);
   EXCEPTION
      WHEN OTHERS THEN
         V_LENGTH := 0;
   END;

   WHILE V_LENGTH > 0 LOOP --> Reverter o nmero: Antes = '0032221213', Depois = '3121222300'
      BEGIN      
         V_NRTEL_OK := SUBSTR(V_EXTRACTED_TEL, V_LENGTH,  1);
      EXCEPTION
         WHEN OTHERS THEN
            V_NRTEL_OK := '';
      END;

      BEGIN
         V_RETURN := V_RETURN || V_NRTEL_OK; 
      EXCEPTION
         WHEN OTHERS THEN
           V_RETURN := '';
      END;

      V_LENGTH := V_LENGTH - 1;   
      
   END LOOP;
 
   RETURN (V_RETURN);
END;
/

--VERSAO--
BEGIN ATUVEROBJ('EXTRACT_TEL','5.01.000'); END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXTRACT_TEL','5.01.002'); END;
/

